package WebFlow.dbServer;

import java.io.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.jdbc.*;
import WebFlow.hashtable.*;
import org.omg.CORBA.*;

public class db_Impl extends BeanContextChildSupport implements dbServerOperations{

  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;
  Jdbc _jdbc;
  ContextData _hash;
  org.omg.CORBA.Object jdbc_object, hashtable_object;
  

  public db_Impl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;
  }

  public org.omg.CORBA.Object myJdbc() { return jdbc_object; }

  public void myJdbc( org.omg.CORBA.Object value ){ 
	jdbc_object = value; 
	System.out.println( "In the myJdbc()." );
//	_jdbc = JdbcHelper.narrow( jdbc_object );
    System.out.println( "narrow jdbc server at dbServer.server side." );
  }

  public void store( org.omg.CORBA.Object table ){
	hashtable_object = table;
	_hash = ContextDataHelper.narrow( hashtable_object );
	System.out.println( "This is store()." );
	String[] temp, _data;
	temp = _hash.getKeys();
	_data = new String[ 5 ];

	for( int i = 0; i < temp.length; i++ ){
		_data[ i ] = _hash.getParam( temp[ i ] );
		_hash.rmParam( temp[ i ] );
	}
	_jdbc.makeRecord( _data[ 0 ], _data[ 1 ], _data[ 2 ], _data[ 3 ], _data[ 4 ] );
	System.out.println( "The store() get parameter:" + _data[ 0 ] + _data[ 1 ] + _data[ 2 ] + _data[ 3 ] + _data[ 4 ] );
  }

  public void restore( org.omg.CORBA.Any storage ){}
		
}
		 


