package WebFlow.FileBrowser;

import WebFlow.*;
import WebFlow.event.*;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import javax.swing.*;


class DummyImp extends _DummyImplBase
{
    public void dummy() {};
}


public class Client 
{
    public static void main(String args[])
    {
        configReader config;
	try
	{
	    System.out.println("Please wait, initializing ORB...");

	    /*
            Properties props = System.getProperties();
            props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
            props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, props);

	    String ref = getIORFromFile(args[0]);
	    boolean flag = true;

	    org.omg.CORBA.Object  obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();

	    WebFlowContext master = WebFlowContextHelper.narrow(obj);
	    if(master == null)
		throw new RuntimeException();
	    System.out.println("Webflow server is connected");

	    obj = master.addNewModule("FileBrowser");	    
	    
	    if(obj == null)
	      throw new Exception("Failed to get module reference");
	    
	    FileBrowser file = FileBrowserHelper.narrow(obj);
	    System.out.println("FileBrowser module reference sucessfully resovled");
	    file.setFileName(".");
	    String[] dirs = file.refreshDirectory(".");

	    System.out.println("Directories list");
	    System.out.println("================");

	    for(int i = 0; i < dirs.length; i++)
		System.out.println(dirs[i]);

	    file.setFileName("..");
	    dirs = file.refreshDirectory("..");

	    System.out.println("Directories list");
	    System.out.println("================");

	    for(int i = 0; i < dirs.length; i++)
		System.out.println(dirs[i]);
	    */

	    org.omg.CORBA.Object obj = new DummyImp();
	    FileBrowser file_b = 
		new _FileBrowserImplBase_tie(new FileBrowserImp(obj, ""));

	    JFrame main_frame = new JFrame("Test window");
	    FileBrowserCtr file_browser = new FileBrowserCtr("/npac/home/webflow/QSData", file_b);
	    main_frame.setBounds(50, 50, 250, 500);
	    main_frame.getContentPane().add(file_browser, BorderLayout.CENTER);
	    main_frame.show();
	} catch(Exception ex) {
	  System.out.println("Exception was thrown: " + ex.getMessage());
	  System.out.println(ex);
	}
    }
  
    
    static public String getIORFromFile(String file_name)
    {
	String ref = null;
	try
	    {
		String refFile = file_name;
		java.io.BufferedReader in =
		    new java.io.BufferedReader(new FileReader(refFile));
		ref = in.readLine();
	    }
	catch(java.io.IOException ex)
	    {
		System.err.println("Can't read from " +
				   ex.getMessage() + "'");
		System.exit(1);
	    }
	return ref;
    }

    static public String getIORFromURL(String aURL) 
    {
	System.out.println("getIORFromFile is called for: " + aURL);
	String IOR = "";
	String thisLine=null;
	try {
	    URL url = new URL(aURL); //create URL java object
	    BufferedReader theHTML = new BufferedReader(new InputStreamReader(url.openStream()));
	    while ((thisLine = theHTML.readLine()) != null)
		IOR += thisLine;
	}
	catch (MalformedURLException e) {
	    System.out.println("GlobalConfig.getIORFromURL: " + aURL + " is not a parseable URL");
	    System.out.println("GlobalConfig.getIORFromURL: " + e);
	}
	catch (Exception e) {
	    System.out.println("GlobalConfig.getIORFromURL: " + e);
	}
	return IOR;
    }
}





