package EDU.syr.npac.frontend.FileBrowserUtil;
import EDU.syr.npac.frontend.*;
import WebFlow.*;
import WebFlow.QS.*;
import java.util.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.*;


import javax.swing.JTextArea;


import javax.swing.JTree;

import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.JScrollPane;

import javax.swing.JPanel;

import javax.swing.JFrame;

import java.awt.GridLayout;

import java.awt.event.WindowListener;

import java.awt.event.WindowAdapter;

import java.awt.event.WindowEvent;

import java.util.Enumeration;

import java.awt.*;

import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import javax.swing.JLabel;

import javax.swing.JTextField;

import javax.swing.event.*;
import javax.swing.tree.*;

public class FBselectedFile extends JTextField implements MouseListener,ActionListener,
TreeExpansionListener
{
public String name;
public String fullFilePath;
FileBrowserCtr viewer;
public String fileSeparator;

public FBselectedFile(String text,int colums,String name_,FileBrowserCtr viewer_)

  {
    super(text,colums);
    name = name_;

    addActionListener(this);
    viewer = viewer_;
    fileSeparator=viewer.fileSeparator;
    System.out.println("FBselectedFile started. FileSeparator is "+fileSeparator);
  }

public void treeExpanded(TreeExpansionEvent event) {
    System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    String newDirName = DirTree.getSelectedItem(selPath);
    System.out.println("newDirName "+newDirName);
    if (newDirName.endsWith("*")) 
      //newDirName=newDirName.substring(0,newDirName.length()-1)+fileSeparator;
      newDirName=newDirName.substring(0,newDirName.length()-1);
    System.out.println("corrected name: "+newDirName);  
    if (name.equals("directory"))
      setText(newDirName);
    fullFilePath = newDirName;
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.out.println("treeCollapsed is Called !!");
  }

 //Erol modifications
public String getEntered()
  {
    System.out.println("getEntered called...");
    String se = getText();
    String fe = fullFilePath;
    System.out.println("FBselectedFile: fullFilePath = "+fullFilePath);

    int pos   = fe.lastIndexOf(fileSeparator);
    if (pos > 0){
      fe  = fe.substring(0,pos)+fileSeparator;
      fe += se;
    }
    else{
      fe += fileSeparator+se;
    }
    System.out.println("RETURN: "+se+" "+fe);
    return fe;
  }

 public void actionPerformed(ActionEvent e) {
   String command = e. getActionCommand();
   System.out.println("actionPerfomed:"+command);
   String entered = getEntered();
 
   
   /* Receive event from directory_field and update fullFilePath */
   java.lang.Object source = e.getSource();

   if (source.getClass().getSuperclass() == this.getClass().getSuperclass()){
     fullFilePath = command;
     System.out.println("getting event from Directory");
     //viewer.GWindow.show();
     return;
   }
   
   if (name.equals("file")){
     System.out.println("File :"+entered+" are sent in ActionPerformed!!!"); 
     //ClientSocket socket = viewer.waitUntilSocketReady() ;

     //socket.send("SWING_REPLY"+entered);

     viewer.fileBrowser.setFileName(entered);

   }
 }


public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  System.out.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  FBDirTree tree = (FBDirTree)source;
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
   
  if (selPath != null){


    System.out.println("-->getSelectedItem");
    fullFilePath = tree.getSelectedItem(selPath);
    int index = fullFilePath.lastIndexOf(fileSeparator);
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);

    System.out.println("one click");
    System.out.println(fullFilePath);
    System.out.println(fileName);
    System.out.println(dirName);

    /* the trick with the * is because I do not know what is the
       file separator in the backend, and getSelectedItem is static
    */

    if(fileName.startsWith("*")) {
       fileName = fileName.substring(1,fileName.length());
    }

    if(dirName.endsWith("*")) {
       dirName = dirName.substring(0,dirName.length()-1)+fileSeparator;
    }

    System.out.println(fileName);
    System.out.println(dirName);

    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Click pressed inside FBselectedfile !!!");

	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }

      else if(e.getClickCount() == 2) {

	System.out.println("Two Cliect pressed inside FBselectedfile !!!");

	if (name.equals("file"))

	  setText(fileName);

	else if (name.equals("directory"))

	  setText(dirName);


	if ((fileName.length() > 0)&&(name.equals("file"))){

	  String entered = getEntered();

	  System.out.println("File :"+entered+" are sent!!!");

	  //ClientSocket socket = viewer.waitUntilSocketReady() ;

	  //socket.send("SWING_REPLY"+entered);

          viewer.fileBrowser.setFileName(entered);

	}

      }

    }

  }

  

}

  



 public void   mouseEntered(MouseEvent e) {;  }

     

 public void     mouseExited(MouseEvent e) {;  }

      

 public void     mousePressed(MouseEvent e) {;  }

      

 public void     mouseReleased(MouseEvent e) {;  }



  

}

