package WebFlow.hashtable;

//WebFlow Project, Leader Tom Haupt
//Farhad Mamedbekov, Summer 99
//String HashTable Implementation


import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
 

public class ContextDataImpl extends WebFlow.BeanContextChildSupport 
                         implements ContextDataOperations {

  //////////////  Variable Declarations ///////////////////////////
  private Hashtable hashtable;
  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;


  public ContextDataImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;

  System.out.println("HashTable's constructor");
  hashtable =  new Hashtable();
 }

  /////////////   method declaration //////////////////////////////
 
  public boolean contains(String value) {
     return hashtable.contains(value);
  }
  
  public boolean containsKey(String key) {
     return hashtable.containsKey(key);
  }
 
  public void remove(String key) {
     hashtable.remove(key);
  }

  //int size() {     return hashtable.size();  }

  public void test() {
        System.out.println("HashTable is up");
  }

  public void setParam(String name, String value) {
       hashtable.put(name,value);
  }

  public String getParam(String name) {
        String value="";
    //return  (String) hashtable.get(name);
    try {
       java.lang.Object obj = hashtable.get(name);
       if (obj!=null) 
          value = (String)obj;
    } catch (Exception e) {System.out.println(e+"while getParam");}
    return value;
  }

  public void rmParam(String name) {
        hashtable.remove(name);
  }

  public String[] getKeys() {
        int n = hashtable.size();
        String[] Keys = new String[n];
        Enumeration K = hashtable.keys();
        int i= 0;
        while(K.hasMoreElements()) {
          Keys[i]=(String)K.nextElement();
          i++;
	}
        return Keys;
  }

}







