package WebFlow;
import WebFlow.event.*;

import java.util.*;

public class myHashMap extends HashMap{

    org.omg.CORBA.ORB orb;
    public myHashMap(int initialCapacity)
    {
	super(initialCapacity);
	Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	System.setProperties(props);
	String []args = {};

	orb = org.omg.CORBA.ORB.init(args, props);
    }
    
    public String getObjStr(Object child)
    {
	BeanContextChild bcc = BeanContextChildHelper.narrow(
				     (org.omg.CORBA.Object)child);
	//System.out.println("myHashMap : getObjjStr:GOT Bfore ID:bc"+bcc+" child:"+child);
	String ID =  bcc.getObjectID();
	//System.out.println("myHashMap : getObjjStr:GOT ID:"+ID);
	return ID;
	//return bcc.getObjectID();
    }

    public boolean containsKey(Object key) 
    {
	return super.containsKey(getObjStr(key));
    }

    public boolean contains(Object key) 
    {
	return super.containsKey(getObjStr(key));
    }

    public Object get(Object key)
    {
	return super.get(getObjStr(key));
    }

    public Object remove(Object key)
    {
	return super.remove(getObjStr(key));
    }
    
    public Object put(Object key, Object value)
    {
	return super.put(getObjStr(key), value);	
    }

    public void putAll(Map t)
    {
	org.omg.CORBA.Object key;
	java.util.Iterator i = t.entrySet().iterator();
	
	while (i.hasNext()) {
	    Map.Entry  tmp  = (Map.Entry)i.next();
	    
	    key = (org.omg.CORBA.Object)tmp.getKey();
	    Object value = tmp.getValue();
	    put(getObjStr(key), value);
	}
    }


    //Parameter is ObjectID
    public boolean containsKey(String key) 
    {
	return super.containsKey(key);
    }

    public boolean contains(String key) 
    {
	return super.containsKey(key);
    }

    public Object get(String key)
    {
	return super.get(key);
    }

    public Object remove(String key)
    {
	return super.remove(key);
    }
    
    public Object put(String key, Object value)
    {
	return super.put(key, value);	
    }

}
