package WebFlow.submitJob;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
 

public class submitJobImpl extends WebFlow.BeanContextChildSupport 
                         implements submitJobOperations {

  String msg_ ; 
  org.omg.CORBA.Object peer ;

  private String user="webflow";
  private String thisHost="osprey4.npac.syr.edu";

  public submitJobImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException {

  super(peer);
  this.peer = peer;
  String msg_ = msg;
 }

  public void test() {
        System.out.println("submitJob is up");
  }


  public void submit(WebFlow.submitJob.CmdLineEvent event) {
    String Host = event.getHost();
    String Rsl = event.getRsl();
    String CmdLine = event.getCmdLine();

  System.out.println("submit called: "+Host+" "+CmdLine);  

    if(Rsl.startsWith("&")) {
       submitGlobus(Host,Rsl,user);
    }
    else {
      if(Host.indexOf(thisHost)>-1) {
       submitLocally(CmdLine);
      }
      else {
       submitRsh(Host,CmdLine);
      }
    } 

  }

  public void submitLocally(String CommandLine) {
   System.out.println("submitLocally: "+CommandLine);
   try {
     Process p = Runtime.getRuntime().exec(CommandLine);
     p.waitFor();        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting the job :"+CommandLine);
     System.err.println(ex);
    }
   }

  public void submitRsh(String host, String CommandLine) {
    CommandLine = "rsh "+host+" "+CommandLine;
    submitLocally(CommandLine);
  }

  public void submitGlobus(String GramKeeper, String RSL, String user) {
    String CommandLine = "/npac/home/globus/globus_1.0/tools/sparc-sun-solaris2.5.1/bin/globusrun";
    CommandLine += " -r "+GramKeeper+" "+RSL;
    submitLocally(CommandLine);
  }    
}







