package WebFlow.test;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class alexeyClient
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
		
	//String WFSname = args[0];
	//String user    = args[1];
	try
	{
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //
	    // Get "hello" object
	    //

            String masterURL = args[0];
	    String ref;
	    org.omg.CORBA.Object obj=null;
	    boolean flag=true;
	    while(flag){
	      ref = getIORFromURL(masterURL);
	      obj = orb.string_to_object(ref);
	      boolean non_exist = true;
	      try{
		non_exist = obj._non_existent();
	      }catch(org.omg.CORBA.COMM_FAILURE ex){}
	       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

	      if (!non_exist)
		flag = false;
              try{
		Thread.sleep(500);
	      }catch(InterruptedException ex){
	      }

	    }

	    if(obj == null)
		throw new RuntimeException();
	    org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[12];

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);
	    ms[0]= ws;
	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Created WFServerHelper");

	     WebFlow.test.arrayHolder holder = new WebFlow.test.arrayHolder();
	     org.omg.CORBA.Object o = ws.addNewModule("alexeyModule");
	     WebFlow.test.alexey mref = WebFlow.test.alexeyHelper.narrow(o);
	     System.out.println("Before op1");
	     mref.op1(holder);
	     System.out.println("After op1");
	     String []list = holder.value;
	     if (list == null)
	        System.out.println("op1 returns null..");
	     else{
	       for(int k=0;k<list.length;k++)
		 System.out.println(list[k]);
	     }

	}catch(Exception e){
	  System.out.println("hhhh:"+e);
	}
    }
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }

};
