package WebFlow.test;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class ClientWhprocess_1
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
		
	//String WFSname = args[0];
	//String user    = args[1];
	try
	{
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //
	    // Get "hello" object
	    //

            String masterURL = args[0];
	    String ref = getIORFromURL(masterURL);
	    org.omg.CORBA.Object obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);
	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Created WFServerHelper");



           /* 
            org.omg.CORBA.Object obj = ws.addNewModule("fff");
            pbsModule pm = pbsModuleHelper.narrow(obj);
            pbsModule.executePBSCommand(......);
           */  

           WebFlowContext ws1;
      	   try{
	        org.omg.CORBA.Object p1,p2,p3,p4,p5,p6,k1,k2,k3,k4,k5,k6;
		BeanContextChild bcc1,bcc2;
		WebFlowContext c1,c2,c3,c4,c5,c6;

		//get Proxy to WebFlow server with name "ali"
		ws = WebFlowContextHelper.narrow(ws.getWFServer("ali"));

		c1 = WebFlowContextHelper.narrow(ws.addNewContext("uc_1"));
		System.out.println("Got c1");
		c2 = WebFlowContextHelper.narrow(c1.addNewContext("uc_2"));
		System.out.println("Got c2");
		c3 = WebFlowContextHelper.narrow(c2.addNewContext("uc_3"));
		System.out.println("Got c3");
		c4 = WebFlowContextHelper.narrow(c3.addNewContext("uc_4"));
		System.out.println("Got c4");
		c5 = WebFlowContextHelper.narrow(c4.addNewContext("uc_5"));
		System.out.println("Got c5");
		c6 = WebFlowContextHelper.narrow(c5.addNewContext("uc_6"));
		System.out.println("Got c6");
		
                
		p1 = c1.addNewModule("hello_1");
		System.out.println("Got p1");
		p2 = c2.addNewModule("hello_2");
		System.out.println("Got p2");
		p3 = c3.addNewModule("hello_3");
		System.out.println("Got p3");
		p4 = c4.addNewModule("hello_4");
		System.out.println("Got p4");
		p5 = c5.addNewModule("hello_5");
		System.out.println("Got p5");
		p6 = c6.addNewModule("hello_6");
		System.out.println("Got p6");


		//From p1- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_1_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_1_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_1_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_1_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_1_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_1_6");
		System.out.println("Got gen p6");


		c1.attachPushEvent(p1,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPushEvent(p1,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPushEvent(p1,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPushEvent(p1,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c1.attachPushEvent(p1,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPushEvent(p1,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");


		//From p2- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_2_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_2_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_2_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_2_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_2_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_2_6");
		System.out.println("Got gen p6");


		c2.attachPushEvent(p2,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c2.attachPushEvent(p2,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c2.attachPushEvent(p2,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c2.attachPushEvent(p2,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c2.attachPushEvent(p2,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c2.attachPushEvent(p2,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");

		
		//From p3- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_3_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_3_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_3_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_3_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_3_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_3_6");
		System.out.println("Got gen p6");


		c3.attachPushEvent(p3,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c3.attachPushEvent(p3,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c3.attachPushEvent(p3,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c3.attachPushEvent(p3,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c3.attachPushEvent(p3,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c3.attachPushEvent(p3,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");

                //From p4- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_4_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_4_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_4_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_4_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_4_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_4_6");
		System.out.println("Got gen p6");


		c4.attachPushEvent(p4,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c4.attachPushEvent(p4,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c4.attachPushEvent(p4,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c4.attachPushEvent(p4,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c4.attachPushEvent(p4,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c4.attachPushEvent(p4,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");


		//From p5- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_5_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_5_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_5_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_5_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_5_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_5_6");
		System.out.println("Got gen p6");


		c5.attachPushEvent(p5,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c5.attachPushEvent(p5,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c5.attachPushEvent(p5,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c5.attachPushEvent(p5,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c5.attachPushEvent(p5,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c5.attachPushEvent(p5,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");

		
		//From p6- > k1,k2,k3,k4,k5,k6////////////////////////////////
                k1 = c1.addNewModule("hellogen_6_1");
		System.out.println("Got gen p1");
		k2 = c2.addNewModule("hellogen_6_2");
		System.out.println("Got gen p2");
		k3 = c3.addNewModule("hellogen_6_3");
		System.out.println("Got gen p3");
		k4 = c4.addNewModule("hellogen_6_4");
		System.out.println("Got gen p4");
		k5 = c5.addNewModule("hellogen_6_5");
		System.out.println("Got gen p5");
		k6 = c6.addNewModule("hellogen_6_6");
		System.out.println("Got gen p6");


		c6.attachPushEvent(p6,"timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c6.attachPushEvent(p6,"timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c6.attachPushEvent(p6,"timeElapsed",k3,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c6.attachPushEvent(p6,"timeElapsed",k4,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
                c6.attachPushEvent(p6,"timeElapsed",k5,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c6.attachPushEvent(p6,"timeElapsed",k6,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");

		

                
		/*c1.attachProperty(p1,"Hidate","getHidate", k1,"setHudate");
		System.out.println("Client: attached property p1-k1");
		c1.attachProperty(p1,"Hidate","getHidate", k2,"setHudate");
		System.out.println("Client: attached property p1-k2");
		*/
        
			

		}catch(PropertyVetoException e){System.out.println("Main:"+e);}
		 catch(WebFlow.NullPointerException e){System.out.println("Main:"+e);}

		/*
		  //WFSname ="wfs2";
		  k1 = ws.create_product(WFSname,user,"hellogen_1");
		  System.out.println("Client: Created hellogen_1");
		  k2 = ws.create_product(WFSname,user,"hellogen_2");
		  System.out.println("Client: Created hellogen_2");
		  */

		 /*
		   ws.attachPushEvent(p1,"timeElapsed",k1,"getTime");
		   System.out.println("Client: attached event p1-k1");
		   ws.attachPushEvent(p1y"timeElapsed",k2,"getTime");
		   System.out.println("Client: attached event p1-k2");
		   */
              

		 /*
		   ws.attachProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
		 
		 /*
		   ws.attachVetoableProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachVetoableProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
	    
		 //ws.disconnect_product("hello_2");
		 //p2 = ws.create_product("hello_2");

		 //
		 // Main loop
		 //
		 System.out.println("Enter 'h' for hello or 'x' for exit:");
	   
	}
	catch(COMM_FAILURE ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }

  
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }
  
  

    
}




