package WebFlow.xsl; 
import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;
import java.io.PrintWriter;

public class Client2{

public static String XmlInput;
public static String HtmlInput;
public static String RSL;
public static String InstallRSL;

   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);

         ORB orb = ORB.init(args, props);

         //  Connect to the master server


         if(args.length !=3) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client2 xml Html");
           System.out.println("    masterURL");
           System.out.println("     xml - xml file containg application descriptor");
           System.out.println("     Html - html file to be created");
           System.exit(1);
	 }    

         String masterURL = args[0] ; 

         XmlInput = args[1];
         File xmlfile = new File(XmlInput);
         if(!xmlfile.exists()) {
            System.out.println("file: "+XmlInput+" does not exist");
            System.out.println("Sorry. Quitting...");
            System.exit(1);
	 }

       //creating HTMl
       //  File htmlfile = new FILE(HtmlInput);
         HtmlInput=args[2];
 //  try {
   //    PrintWriter htmlfile  = new PrintWriter(new FileOutputStream(new
     //       File(HtmlInput)));                                       
       //          } catch (Exception e) {e.printStackTrace();}
         //       System.out.println("HTML FILE CREATED");
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
          org.omg.CORBA.Object p1 = ws.addNewModule("XslServer"); 
          XslServer parser = XslServerHelper.narrow(p1);

		parser.test();
                parser.converthtml(HtmlInput,XmlInput);

			}catch (COMM_FAILURE X){
                            System.out.println("error");
                    }           

  }


 static public String getIORFromURL(String url) {
                
   System.out.println("Slave WebFlow is getting IOR from url:"+url);
   String masterServerIOR ="";
   String thisLine = null ;
                
   // Open the URL for reading
                  
   try{
        URL u = new URL(url);
                   
        // now turn the URL into a DataInputStream
                      
        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());
      
          while((thisLine = theHTML.readLine()) != null){
             masterServerIOR += thisLine ;
          }
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }          
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ;  
  }




}
