package WebFlow.CRPC;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import WebFlow.submitJob.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*; 
import java.awt.event.*; 
//import javax.swing.*;

public class CRPCMain extends java.lang.Object
{
  // private static CrpcSelectList  f;
  // private static Button Button1,Button2;
  //private static Panel searchPanel;
  //private static TextField name;
 public static String XmlInput;
 public static String RSL;
 public static String InstallRSL;
 public static submitJob submit;

private static WebFlowContext ws;
private static org.omg.CORBA.Object p1,p2;
private static XmlServer parser;
private static String display;
 

  public static boolean connected(String args[]){
      try
      {
       //  Create ORB
        Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);
         ORB orb = ORB.init(args, props);
         String masterURL = args[0] ; 
         XmlInput = args[1];
         display=args[2]; 
         File xmlfile = new File(XmlInput);
         xmlfile = new File(XmlInput); 
         if(!xmlfile.exists()) {
            System.out.println("file: "+XmlInput+" does not exist");
            System.out.println("Sorry. Quitting...");
            System.exit(1);
	     }
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 
         ref = getIORFromURL(masterURL);
         System.out.println("REF: "+ref); 
         obj = orb.string_to_object(ref); 
         if(obj == null)
              throw new RuntimeException(); 
         ws =  WebFlowContextHelper.narrow(obj); 
         System.out.println("Clinet: got master "+ws);
         if(ws == null)
               throw new RuntimeException();
         System.out.println("attach XmlServer------------------------"); 
         p1 = ws.addNewModule("XmlServer");
         XmlServer parser = XmlServerHelper.narrow(p1);   
         System.out.println("attach submitJob------------------------");                p2 = ws.addNewModule("submitJob");
         submit = submitJobHelper.narrow(p2);
       	  submit.test();
          parser.test();
          System.out.println("DISPLAY is set to: "+display);
          System.out.println("recompile ClientS to change");
          String command="xterm -d "+display;
         }
       catch(COMM_FAILURE ex)
	   {
          System.out.println("Command_Error: "+ex);
          System.err.println(ex.getMessage());
          ex.printStackTrace(); 
        		   System.exit(1); 
	   } 
    return true;
 };

static public String getIORFromURL(String url) {
    System.out.println("Slave WebFlow is getting IOR from url:"+url);
    String masterServerIOR =""; 
    String thisLine = null ;
   // Open the URL for reading
    try{
         URL u = new URL(url);       
        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());
         while((thisLine = theHTML.readLine()) != null){ 
         masterServerIOR += thisLine ;      } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ; 
  }


// main function
  public static void main(String args[])
  {
   //  Connect to the master server
         if(args.length !=3) 
           {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.out.println("     xml - xml file containg application descriptor");
           System.out.println("    display"); 
           System.exit(1);
	     }    
	 
         if (connected(args))
            {
           
            CRPCFrame app = new CRPCFrame(submit,display);
            app.addWindowListener(
	      new WindowAdapter(){
		public void windowClosing(WindowEvent e){
                  ws.detachPushEvent(p1,"submit",p2,"submit"); 
	          ws.removeModule(p1);
	          ws.removeModule(p2);
                  System.exit(0);
                  }
                }
              );
            }
         
         else{
             System.out.println("connection failed"); 
             }
	
  };
}

















