package WebFlow.ContextManager;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
 

public class ContextManagerImpl extends WebFlow.BeanContextChildSupport 
                         implements ContextManagerOperations {

  String msg_;
  org.omg.CORBA.Object peer;
  boolean debug = true;

  public ContextManagerImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  this.peer = peer;
  String msg_ = msg;
 }

  public void test(){
   System.out.println("Context manager is up");
  } 

  public WebFlowContext[] makeListOfContexts(WebFlowContext root, 
                                                    String suffix) {
       // all contexts are returned, possibly of different kind!
      if(debug) System.out.println("suffix="+suffix);
      Vector list = new Vector();
      org.omg.CORBA.Object[] ContextObjs=root.toArray();
     if(debug) System.out.println("number of objects === "+ContextObjs.length);
      for(int i=0; i<ContextObjs.length;i++) {
         WebFlow.BeanContextChild Something=null;
         Something=BeanContextChildHelper.narrow(ContextObjs[i]);
         String ObjectName=Something.getObjectID();
         System.out.println("Name: "+ObjectName);
         if(ObjectName.endsWith(suffix)) {
           WebFlowContext c = WebFlowContextHelper.narrow(ContextObjs[i]);
           list.addElement(c);
	 }
      } 
      // convert Vector to Array
      int n = list.size();
      WebFlowContext[] result = new WebFlowContext[n]; 
      for(int i=0;i<n;i++) {
        result[i]=(WebFlowContext)list.elementAt(i);
      }
      return result; 
     }


}







