package WebFlow.demo; 
import WebFlow.event.*; 
import WebFlow.*; 
import java.util.*; 

import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 

public class ResponseImpl extends BeanContextChildSupport
                  implements WebFlow.demo.ResponseOperations
{
   String msg_ ; 
   org.omg.CORBA.Object peer ; 

   public static int numClicks = 0 ;   // number of button clicks 
   public static String message = "Number of Button Clicks:"+numClicks;
   public static JLabel label2 = new JLabel(message); 
   public static JButton beep = new JButton("Beep"); 

   public static final  JFrame frame2 = new JFrame("Action Response");

   public Component createComponents(){
        
         JPanel pane2 = new JPanel(); 
         pane2.setBorder(BorderFactory.createEmptyBorder(10,10,10,10)); 
         pane2.setLayout(new GridLayout(0,1)); 
         pane2.add(beep); 
         pane2.add(label2); 
  
         beep.setBackground(Color.cyan); 
         beep.setForeground(Color.blue); 

         return pane2; 
    }

   public ResponseImpl(org.omg.CORBA.Object peer , String msg) 
           throws WebFlow.NullPointerException
   {
      super(peer); 
      this.peer = peer ; 
      msg_ = msg ; 
    
   // final JFrame frame2 = new JFrame("Action Response"); 

      frame2.getContentPane().add(createComponents() , BorderLayout.CENTER); 

   // Finish setting up the frame , and show it

      frame2.setLocation(400,200);
      frame2.pack(); 
      frame2.setVisible(true); 
    }   

   public  void act(actionEvent e)
   {
     //System.out.println("start act...");
     Toolkit.getDefaultToolkit().beep();
     beep.setBackground(Color.red); 
     beep.setForeground(Color.black); 
     numClicks++ ; 
     message = "Number of Button Clicks:" +numClicks; 
     label2.setText(message); 
     //System.out.println("...end act");
   }

   public void getEvent(org.omg.CORBA.Object to)
   {
      //System.out.println("getEvent is called: ResponseImpl"); 
     
      actionEvent gevt = actionEventHelper.narrow(to); 
      
      String eType = gevt.eventType();

      beep.setBackground(Color.cyan);
      beep.setForeground(Color.blue);

      if(eType.equals("Fire"))
      {
         //System.out.println("I got an fire_event") ;
         act(gevt); 
         //System.out.println("action performed");
      }
      else if(eType.equals("Reset"))
     {
         //System.out.println("I got an reset event") ;
         numClicks = 0 ; 
         message = "Number of Button Clicks:" +numClicks;
         label2.setText(message); 

      }
      else if(eType.equals("Quit"))
      {
         //System.out.println("I got a quit event"); 
      }
     //System.out.println("that's it");
   }

   public void connectOK(String msg)
   {
     //System.out.println("OK : "+msg+" from ResponseImpl"); 
   }

}








