package WebFlow.FileBrowser.FileBrowserUtil;

import java.io.File;

public class TreeNodeInfo
{
    public String filename;
    public boolean isDir;
    
    public TreeNodeInfo (String fileInfo)
    {
	if(fileInfo.startsWith("<DIR>")) {
	    isDir = true;
	    filename = fileInfo.substring(6);
	}
	else {
	    isDir = false;
	    filename = fileInfo;
	}
    }
    
    public void setDummyFileName()
    {
	filename = ".."+File.separator;
	setDir();
    }
    
    public boolean isDummyFileName()
    {
	String dummyname = ".." + File.separator;
	if (filename.equals(dummyname))
	    return true;
	return false;
    }
    
    public void setDir() {
	isDir = true;
    }

    public String toString(){
	return filename;
    } 
}   


