package WebFlow.FileBrowser;

import java.util.*;

import java.net.*;
import java.io.*;

public class WFFileDescriptorImp extends _WFFileDescriptorImplBase
{
    
    private String FileName;
    private String FileDirectory;
    private String FileHost;
    private String FileAttribute;
    org.omg.CORBA.Object source;
  

    public org.omg.CORBA.Object getSource()
    {
	return source;
    }
    
    
    public WFFileDescriptorImp(org.omg.CORBA.Object source, String Name, String Directory, String Host, String A) {
	this.source = source;
	FileName = Name;
	FileDirectory = Directory;
	FileHost = Host;
	FileAttribute = A;
  }
    
    public WFFileDescriptorImp(org.omg.CORBA.Object source,String Name, String Directory, String Host) {
	this.source = source;
	FileName = Name;
	FileDirectory = Directory;
	FileHost = Host;
	FileAttribute = null;
    }
    
    public WFFileDescriptorImp(org.omg.CORBA.Object source,String Name, String Directory) {
	this.source = source;
	FileName = Name;
	FileDirectory = Directory;
	try {
	    InetAddress local = InetAddress.getLocalHost();
	    FileHost = local.getHostName();
	} catch(UnknownHostException e) {System.out.println(e);}
	FileAttribute = null;
    }
    
    public WFFileDescriptorImp(org.omg.CORBA.Object source,String Name) {
	this.source = source;
	FileName = Name;
	FileDirectory = "C:\\tmp\\";
	try {
	    InetAddress local = InetAddress.getLocalHost();
	    FileHost = local.getHostName();
	} catch(UnknownHostException e) {System.out.println(e);}
	FileAttribute = null;
    }
    
    public WFFileDescriptorImp(org.omg.CORBA.Object source) {
	this.source = source;
	FileName = "dummy";
	FileDirectory = "C:\\tmp\\";
	try {
	    InetAddress local = InetAddress.getLocalHost();
	    FileHost = local.getHostName();
	} catch(UnknownHostException e) {System.out.println(e);}
	FileAttribute = null;
    }
    
    public String getFileName() {return FileName;}
    public String getFileDirectory() {return FileDirectory;}
    public String getFileHost() {return FileHost;}
    public String getFileAttribute() {return FileAttribute;}
    
    public void setFileName(String Name) {FileName=Name;}
    public void setFileDirectory(String Name) {FileDirectory=Name;}
    public void setFileHost(String Name) {FileHost=Name;}
    public void setFileAttribute(String Name) {FileAttribute=Name;}
    
}
