package WebFlow;
import java.io.*;

public class printProcessOut implements Runnable
{
  Process p_;
  InputStream is;
  InputStream error_is;
  BufferedReader br ,error_br;
  
  public printProcessOut (Process p)
  {
    p_ = p;
    is = p_.getInputStream();
    br = new BufferedReader(new InputStreamReader(is));

	error_is = p_.getErrorStream();
    error_br = new BufferedReader(new InputStreamReader(error_is));
	new readError().start();
	
  }
   
  public String getIOROfProcess()
  {
    String s=null;
    try{
      //while( (s=br.readLine()).indexOf("IOR")<0) ;
      while( (s=br.readLine()) !=null){
	System.out.println("printProcessOut:read:"+s);
	if (s.indexOf("IOR")==0)
	  break ;
      }
      
      }catch(IOException ex){
		System.out.println("IOE during reading from process");
    }
	return s;
  }

  public void startProcess()
  {
	Thread thr = new Thread(this);
    thr.start();
  }

   public void run()
  {
    String s;
    
    while(true){
      try{
	s = br.readLine();
	if (s != null)
	  System.out.println(s);

	//test
	else 
	  break;
	//test

      }catch(IOException ex){
	System.out.println("IOE during reading from process");
      }
    }
  }

  class readError extends Thread{

	public void run()
	{
		String s;
        while(true){
			try{
				s = error_br.readLine();
				if (s != null)
					System.out.println("Print Process Error:"+s);
			}catch(IOException ex){
				System.out.println("IOE during reading from process");
			}
		}
	}
  } //class readError

}
