package WebFlow.test;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class Client 
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
		
	//String WFSname = args[0];
	//String user    = args[1];
	try
	{
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //
	    // Get "hello" object
	    //

            String masterURL = args[0];
	    String ref = getIORFromURL(masterURL);
	    org.omg.CORBA.Object obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);
	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Created WFServerHelper");



           /* 
            org.omg.CORBA.Object obj = ws.addNewModule("fff");
            pbsModule pm = pbsModuleHelper.narrow(obj);
            pbsModule.executePBSCommand(......);
           */

           WebFlowContext ws1;
      	   try{
	        org.omg.CORBA.Object p1,p2,k1,k2,k;
		BeanContextChild bcc1,bcc2;
		WebFlowContext c1,c2,c3,wsr;
	    

		ws = WebFlowContextHelper.narrow(ws.getWFServer("ali"));
		//wsr = WebFlowContextHelper.narrow(ws.getWFServer("ntserver"));
		System.out.println("Client: got ws");
		c1 = WebFlowContextHelper.narrow(ws.addNewContext("uc_1"));
		System.out.println("Client: got c1:"+c1);
		c2 = WebFlowContextHelper.narrow(c1.addNewContext("uc_2"));
		//c2 = WebFlowContextHelper.narrow(wsr.addNewContext("uc_2"));
		System.out.println("Client: got c2:"+c2);
		//test
		//c2 = WebFlowContextHelper.narrow(c1.addNewContext("uc_1"));
		//c2 = WebFlowContextHelper.narrow(ws.addNewContext("uc_2"));
		
		p1 = c1.addNewModule("hello_1");
		System.out.println("Client: got p1");
		p2 = c1.addNewModule("hello_2");
		System.out.println("Client: got p2");

        
		k1 = c2.addNewModule("hellogen_1");
		System.out.println("Client: got k1");
		k2 = c2.addNewModule("hellogen_2");
		System.out.println("Client: got k2");
	    

		hellogen hg = hellogenHelper.narrow(k1);
		hg.sayHello("Ali geldi Okula Cikti");
		

		/*System.out.println("Size :"+c1.size());
		k = c1.getNamedChild("hello_1");
		bcc1  = BeanContextChildHelper.narrow(k);
		System.out.println("c1:"+bcc1);
		//boolean b = bcc1.IsChildProxy();
		//System.out.println("IsChildProxy :"+b);
		*/
		
		c1.attachPushEvent(p1,"Timer","timeElapsed",k1,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k1");
		c1.attachPushEvent(p1,"Timer","timeElapsed",k2,"getTime");
		System.out.println("CLIENT: ATTACHED EVENT???????????????? p1-k2");
		

		}catch(PropertyVetoException e){System.out.println("Main:"+e);}
		 catch(WebFlow.NullPointerException e){System.out.println("Main:"+e);}

		/*
		  //WFSname ="wfs2";
		  k1 = ws.create_product(WFSname,user,"hellogen_1");
		  System.out.println("Client: Created hellogen_1");
		  k2 = ws.create_product(WFSname,user,"hellogen_2");
		  System.out.println("Client: Created hellogen_2");
		  */

		 /*
		   ws.attachPushEvent(p1,"Timer","timeElapsed",k1,"getTime");
		   System.out.println("Client: attached event p1-k1");
		   ws.attachPushEvent(p1,"Timer","timeElapsed",k2,"getTime");
		   System.out.println("Client: attached event p1-k2");
		   */
              

		 /*
		   ws.attachPushProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachPushProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
		 
		 /*
		   ws.attachPushVetoableProperty(p1,"Hidate","getHidate", k1,"setHudate");
		   System.out.println("Client: attached property p1-k1");
		   ws.attachPushVetoableProperty(p1,"Hidate","getHidate", k2,"setHudate");
		   System.out.println("Client: attached property p1-k2");
		   */
	    
		 //ws.disconnect_product("hello_2");
		 //p2 = ws.create_product("hello_2");

		 //
		 // Main loop
		 //
		 System.out.println("Enter 'h' for hello or 'x' for exit:");
	   
	}
	catch(COMM_FAILURE ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }

  
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }
  
  

    
}




