package WebFlow.test;
import WebFlow.*;
import java.util.*;
import WebFlow.event.*;



public class helloImpl_1 extends BeanContextChildSupport
                       implements helloOperations, Runnable
{
  String msg_;
  long interval;
  String Hidate="Erol_1";
  org.omg.CORBA.Object peer_;

  public helloImpl_1(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);
    
    msg_ = msg;
    interval = 1000;   
    Thread thr = new Thread(this);
    thr.start();
   }
  
  public void setHidate_att (String newVal)
  {
    String oldVal = Hidate;
    Hidate        = newVal;
    firePropertyChange("Hidate",oldVal,newVal);
  } 

  public void setHidate (String newVal) throws PropertyVetoException
  {
    String oldVal = Hidate;
    Hidate        = newVal;
    fireVetoableChange("Hidate",oldVal,newVal);
    
    System.out.println("helloImple_1: survived, so not veto");
    //survived, so not veto
    firePropertyChange("Hidate",oldVal,newVal);
  }  

  public String getHidate ()
  {
    return Hidate;
    
  }
  
  //public void run_event()
  public void run()
  {
    while(true){
      try{
	Thread.sleep(interval);
      }catch(InterruptedException ex){
      }
      System.out.println("Hello in run..: 1");
      timerEvent tevt = new timerEventImpl(getBeanContextChildPeer());
      fireEvent("timeElapsed",tevt);
      if (getBeanContext() == null)
	break;
    }
    
  }

  //public void run()
       public void run_property()
  {
    while(true){
      try{
	Thread.sleep(interval);
      }catch(InterruptedException ex){
      }
      System.out.println("Hello in run..: 1");
      Date  now  = new Date();
      String newVal = "Hello_1:"+now.toString();
      setHidate_att(newVal); 
    }
    
  } 

public void run_VetoableaChange() 
  {
    while(true){
      try{
	Thread.sleep(interval);
      }catch(InterruptedException ex){
      }
      System.out.println("Hello in run..: 1");
      Date  now  = new Date();
      String newVal = "Hello_1:"+now.toString();
      try{
	setHidate(newVal); 
      }catch(PropertyVetoException ex){
	System.out.println("Hello_1 got Exception :"+ex);
      }
      
      
    }
    
  } 


 public void sayHello()
  {
    System.out.println("Hello :"+msg_+" from helloImpl_1");
  }
  

public void addTimerListener(org.omg.CORBA.Object timerListener)
  {
    addPropertyChangeListener(timerListener);
  }

public void removeTimerListener(org.omg.CORBA.Object timerListener)
  {
    removePropertyChangeListener(timerListener);
  }
 }
