//Server.java
//package core;
package WebFlow;

import java.util.*;
import java.net.*;
import java.io.*;
import java.lang.reflect.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.*;

public class ProxyImpl  extends  org.omg.CORBA.DynamicImplementation
 {

  org.omg.CORBA.ORB orb;
  Hashtable interfacedef;
  Vector idsVec;
  org.omg.CORBA.Object  myWebFlowContext_;
  String []myIRid;
  configReader ConfigServer;
  org.omg.CORBA.Object childPeer;
  String productName;
  Class childPeerClass = null;
  boolean remote;
  org.omg.CORBA.Object container;
  Hashtable interfacedefForContainer;
  String attr="NOTINIT";
  moduleFactory factory;
  WebFlowContext myContainer  ;
  org.omg.CORBA.Repository repository ;
 
public String[] _ids()
  {
    return myIRid;
  }
     
     //public ProxyImpl(String productName, org.omg.CORBA.Object remoteObj,
     //		    org.omg.CORBA.ORB orb, configReader ConfigServer)
public ProxyImpl(String productName, org.omg.CORBA.Object remoteObj,
		 org.omg.CORBA.ORB orb,  moduleFactory factory,String attr)
  {   
    String IRid;
    String implClassName=null;
    Class implClass=null,tieClass=null;
    java.lang.Object implObj   = null;
    org.omg.CORBA.Object tieObj=null;
    Constructor[] constructors = null;
    String OpsInterface=null;  
    int k;

    this.attr = attr;
    this.orb = orb;
    this.productName = productName;
    childPeer = remoteObj;
    this.factory = factory;
    remote = true;
    interfacedef = new Hashtable();
    idsVec = new Vector();

    setInterfaceDesc(remoteObj,null);
    myIRid = new String[idsVec.size()];
    for(k=0;k<idsVec.size();k++)
	myIRid[k] = (String)idsVec.elementAt(k);

    //System.out.println("ProxyImpl:setIrid: MYID:"+orb.object_to_string(this));
  }
   
    public ProxyImpl(String productName, org.omg.CORBA.Object remoteObj,
		     org.omg.CORBA.ORB orb, moduleFactory factory )
  {
    String IRid;
    String implClassName=null;
    Class implClass=null,tieClass=null;
    java.lang.Object implObj   = null;
    org.omg.CORBA.Object tieObj=null;
    Constructor[] constructors = null;
    String OpsInterface=null;  
    int k;

    attr = "CONTEXT";
    this.ConfigServer = ConfigServer;
    this.orb = orb;
    this.productName = productName;
    childPeer = remoteObj;
    this.factory = factory;
    remote = true;
    interfacedef = new Hashtable();
    idsVec = new Vector();
    getRepository();

    setInterfaceDesc(remoteObj, null);
    myIRid = new String[idsVec.size()];
    for(k=0;k<idsVec.size();k++)
	myIRid[k] = (String)idsVec.elementAt(k);
    System.out.println(attr+"ProxyImpl:setIrid: MYID:"+orb.object_to_string(this));
      
  }
    
 public void getRepository()
  {
      org.omg.CORBA.Object obj;

      try
	{
	  obj = orb.resolve_initial_references("InterfaceRepository");
	}
      catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	  throw new org.omg.CORBA.INTF_REPOS();
	}
      
      if(obj == null)
	{
	  throw new org.omg.CORBA.INTF_REPOS();
	}
      
     repository = org.omg.CORBA.RepositoryHelper.narrow(obj);
  }


public void invoke(org.omg.CORBA.ServerRequest request)
  {
     String opname = request.op_name();
     try{
       //System.out.println(attr+"BC:invoke:Now I will make DII for request:"+opname+"-");
       RemoteInvoke(request);
       //System.out.println(attr+"RemoteInvoke: I succesfully INVOKED ...:"+
       //	  opname);
       return;
     }catch(org.omg.CORBA.BAD_OPERATION e){
       //System.out.println("BC:invoke:ChilImpl:request: "+opname+" came into here");
     }
     //System.out.println(attr+"BC:invoke:ENDDD:Now I will make DII for request:"+opname+"-");
     forwardFireEvent(request);
  }

   public void RemoteInvoke(org.omg.CORBA.ServerRequest request) 
   //public void invoke(org.omg.CORBA.ServerRequest request) 
  {
    String opname = request.op_name();
    //System.out.println(attr+"Proxy: "+opname+" Called..");

          
    //If the requested operation is not supported this proxy's actual object
    //throw exception
    OperationDescription opdef;
    opdef = (OperationDescription)interfacedef.get(opname);

    if (opdef == null){
      //System.out.println(attr+"OOOOOPPPPPPS I could not find interface desc:"+
      //	 opname);  
      throw new org.omg.CORBA.BAD_OPERATION();
    }
        
    org.omg.CORBA.NVList params = orb.create_list(0);
    ParameterDescription []paramdefs = opdef.parameters;
    for(int k=0;k<paramdefs.length;k++)
      {
	  org.omg.CORBA.Any nameAny = orb.create_any();
	  TypeCode type = paramdefs[k].type;
	  nameAny.type(type);
	  String name = paramdefs[k].name;
	  org.omg.CORBA.ParameterMode mode = paramdefs[k].mode;
	  params.add_value(name, nameAny, mode.value()+1);
	  //System.out.println(attr+" opname:"+opname+" paramsinFo:"+k+
	  //" :"+type.kind().v       alue()+ " name:"+name+" modeval:"+mode.value());
    }
    // obtains the params from the request
    request.params(params);
    
 
    //receive incoming context
    //We sent always context info of source modules with fire event
    String objectID = null;
    if (opname.equals("propertyChange") || opname.equals("vetoablePropertyChange")||opname.equals("pullEvents"))
	objectID = extractObjectID(request);
    //Receive Context Info
    //System.out.println(attr+"Proxy:invoke:after request.params");
      
      
    //forward the request to its actual object
    String  forward_opname = opname;
    TypeCode result_type = opdef.result;
    org.omg.CORBA.Object forward_childPeer = childPeer;
    //System.out.println(attr+"I GOT OPERATION :"+forward_opname);
    if (forward_opname.equals("changeImpl")){
      //System.out.println(attr+"CHANGEIMPL command: changing forward request..");
	forward_opname = "addNewModule";
	result_type = orb.create_interface_tc("IDL:omg.org/CORBA/Object:1.0", "Object");
	BeanContextChild bcc = BeanContextChildHelper.narrow(childPeer);
	forward_childPeer = bcc.getBeanContext();
	opdef.result = result_type;
    }

    org.omg.CORBA.Any nameAny = orb.create_any();
    nameAny.type(result_type);
    NamedValue result = orb.create_named_value("",nameAny,org.omg.CORBA.ARG_OUT.value);
   
    Request forward_request;
    forward_request = forward_childPeer._create_request(orb.get_default_context(),
						  forward_opname,params,result);
    //append incoming context Info
    if (objectID != null)
	insertContextInfo(forward_request, objectID);  
    //append context Info

    if (opname.equals("destroy")){
      boolean flag = deactivate(true);
      if (flag)
	return;
    }


    //System.out.println(attr+"Proxy:invoke:before forward_request.invoke:"+
    //	forward_request);
    forward_request.invoke();

    //System.out.println(attr+"Proxy:invoke:after forward_request.invoke");
    java.lang.Exception e = forward_request.env().exception();
    if(e != null){
      System.out.println(attr+"Proxy:invoke:after GOT exception:"+e+" for:"+forward_opname);
      Any any = orb.create_any();
      any.insert_string(e.toString());
      request.except(any);
    }
    //else 
    //System.out.println(attr+"Proxy:invoke PASSED OK: for:"+opname);
    
   //return result to Applet Client
    org.omg.CORBA.Any  delegateResult = createProxyForRemote(opdef, forward_request,
							     opname);
    request.result(delegateResult); 
    //System.out.println(attr+"Proxy:INVOKE returned..");
    
    //System.out.println(attr+"Proxy:opnname:"+opname+" BEFORE IF");
    if (opname.equals("destroy")){
        orb.disconnect(childPeer);
        //System.out.println(attr+"Proxy:destroy Remote Module for:"+opname);
        orb.disconnect(this);
    } 
    
    if (opname.equals("removeMyself")){
       System.out.println("ProxyIMPL: REMOVEMYSELF EXITED :");
       deactivate(false);
    }
    
  }   
   

public boolean  deactivate (boolean isDestroy)
  {
    System.out.println("ProxyIMPL: Deactivate Entered :");
       
       BeanContextChild bcc=null;
       org.omg.CORBA.Object context=null;
       WebFlowContext wfc=null;
       boolean existent = false;
       try{
	 bcc = BeanContextChildHelper.narrow(childPeer);
	 wfc = WebFlowContextHelper.narrow(childPeer);
	 context = bcc.getBeanContext();
	 existent=true;
       }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
 
       if ( (existent && (context == null ) &&(!isDestroy)) ||
	 (existent && bcc.isWFServer() ))
	 {
	    System.out.println("ProxyIMPL:Deactivating ....:"+bcc.getObjectID()+
			       " size:"+wfc.size());
	   moduleFactory redFactory = factory.prevChild();
	  		
	   //new deactivateServer(wfc,redFactory);
	   	   
	   try{
	     wfc.deactivate();
	   }catch(org.omg.CORBA.COMM_FAILURE ex) {}

	   return true;
	 }
       else
	 return false;
  }
   


   class deactivateServer implements Runnable{
     WebFlowContext wfc,parent;
     moduleFactory redFactory ;String ID;
     
     public deactivateServer (WebFlowContext wfc,moduleFactory redFactory )
     {
       this.wfc = wfc;
       this.redFactory = redFactory;
       
       parent = WebFlowContextHelper.narrow(wfc.getBeanContext());
       ID = wfc.getObjectID();
       Thread thr = new Thread(this);
       thr.start();
     }

     public void run()
     {
       boolean flag=true;  
       while(flag){
	 int s = wfc.size();
	 System.out.println(ID+" waiting for children to be deleted:size:"+s);
	 if ((s == 0) && (wfc.isAllChildrenDeleted()))
	   break;
	 try{
	   Thread.sleep(500);
	 }catch(InterruptedException ex){ }
       }

       try{
	 wfc.deactivate();
       }catch(org.omg.CORBA.COMM_FAILURE ex) {}

       try{
	 redFactory.deactivate();
       }catch(org.omg.CORBA.COMM_FAILURE ex) {}

       //Inform parent
       if (parent != null)
	 parent.setChildDeleted(ID);
     }
   }

public  org.omg.CORBA.Any createProxyForRemote(OperationDescription opdef, 
					 Request request, String opname)
    {
	TypeCode result_type = opdef.result;
	org.omg.CORBA.Object proxy=null;
	Any returnVal = request.result().value();

	if ((result_type.kind().value() != org.omg.CORBA.TCKind._tk_objref)||
	    (request.operation().equals("getWFServer"))||
	    (request.operation().equals("getBeanContextChildPeer"))||
	    (request.operation().equals("getBeanContext"))||
	     (request.operation().equals("getContext"))||
	     (request.operation().equals("getMyProxy")) ||
	     (request.operation().equals("getParentContext")) ||
	     (request.operation().equals("getContextExtended")) )
	{  
	  //System.out.println(attr+"createProxyForRemote:Proxy got NOT Object as return val:"+ result_type.kind().value()+" for:"+opname);
	    return returnVal;
	}
	//else
	//System.out.println(attr+"createProxyForRemote:Proxy got Object as return val:"+opname); 
	
	org.omg.CORBA.Object returnObj = returnVal.extract_Object();
	//System.out.println(attr+"createProxyForRemote:returnObj:"+ returnObj+" factory:"+factory);
	if (opname.equals("changeImpl")){
	  //System.out.println(attr+"createProxyForRemote:Disconnect old impl:");
	    BeanContextChild bcc = BeanContextChildHelper.narrow(childPeer);
	    myContainer = WebFlowContextHelper.narrow(bcc.getBeanContext()); 
	    myContainer.copyModuleBinding(childPeer,returnObj);
	    myContainer.removeModuleProxy(childPeer, false);
	    childPeer = returnObj;
	    return returnVal;
	}
	
	//Return value is WebFlow Context
	if (returnObj._is_a("IDL:WebFlow/BeanContext:1.0")){
	  //System.out.println(attr+"Before Proxy got Context Object"); 
	    proxy = factory.addProxyContext(childPeer,returnObj);
	    // System.out.println(attr+"Proxy got Context Object"); 
	}
	//Return Value is User Module
	else if (returnObj._is_a("IDL:WebFlow/BeanContextChild:1.0")){
	   proxy =  factory.addProxyChild(childPeer,returnObj); 
	   //System.out.println(attr+"Proxy got Child Object"); 
	}
	//else
	//System.out.println(attr+"Proxy got Unknown-typed Object");  

	//put the proxy into Any
	org.omg.CORBA.Any any = orb.create_any();
	any.insert_Object(proxy);
	return any;
    }

public void insertContextInfo(Request request)
    {
	Context context = orb.get_default_context();
	Any val = orb.create_any();
	//add one method to BeanContextChild class , getIRid() and setIRid()
	val.insert_string(myIRid[0]+"--"+myIRid[1]+"Erol");
	context.set_one_value("IRid", val);

	//set Context of Request Object
	//the parameter of add method ("IR*") specifies which values of context
	//will be sent through. Here we say "sent all attributes starting with "IR"
	request.contexts().add("IR*");
	request.ctx(context);
	//System.out.println(attr+"insertContextInfo appended Context Info.");
    }

public void setInterfaceDesc(org.omg.CORBA.Object product_, InterfaceDef nextDef )

  {
    InterfaceDef idef=null;
    FullInterfaceDescription  fullInterfaceDesc=null;

    //System.out.println("setInterfaceDesc:after get_interface: starting");
    if (nextDef == null){
      if (attr.equals("CONTEXT")){
	org.omg.CORBA.Contained contained = repository.lookup_id(
					(_WebFlowContextImplBase._ob_ids_)[0]);	
	idef = org.omg.CORBA.InterfaceDefHelper.narrow(contained);
	//System.out.println("setInterfaceDesc: Firsdt");
      }
      else{
	//System.out.println("setInterfaceDesc: SecondFirsdt");
	//idef = product_._get_interface();
	idef = (InterfaceDef)(product_._get_interface());
      }
    }
    else
      idef = nextDef;
    
    //System.out.println("setInterfaceDesc:after get_interface:");

    fullInterfaceDesc = idef.describe_interface();  
    //System.out.println("setInterfaceDesc:after describe_interface"+fullInterfaceDesc);
    //System.out.println("setInterfaceDesc:after describe_interface :IRid:"+
    //     fullInterfaceDesc.id);
   
    idsVec.add(fullInterfaceDesc.id);
    OperationDescription []ods = fullInterfaceDesc.operations;
    for(int k=0;k<ods.length;k++){ 
      OperationDescription kops = ods[k];
      interfacedef.put(kops.name,kops);
      //System.out.println(attr+"SetInterfaceDesc:I am putting opname:"+kops.name);
    }   
    
    InterfaceDef []idefs = idef.base_interfaces();
    for (int b=0;b<idefs.length;b++){  
      //System.out.println(attr+"SetInterfaceDesc:Recursing Counter b:"+b);
      setInterfaceDesc(product_, idefs[b]);
    }  
  }
   
    public boolean setMyContainer(String opname, org.omg.CORBA.NVList nvl)
   {
     if (!opname.equals("setBeanContext"))
       return false;
     
     //System.out.println(attr+"setMyContainer called for :"+opname);
     try{
       NamedValue nv = nvl.item(0);
       Any val = nv.value();
       container = val.extract_Object();
       nvl.remove(0);
     }catch(org.omg.CORBA.Bounds e){
       //System.out.println(attr+"Bounds Exception..."+e);
     }
     Any nameAny = orb.create_any();
     nameAny.insert_Object(this);
     nvl.add_value(opname, nameAny, 1);
     return true;
     
   }

 public void insertContextInfo(Request request, String ID)
    {
	//System.out.println("PCS:insertContextInfo Entered");
	Context context =orb.get_default_context();
	Any val = orb.create_any();

	//add ObjectID to outgoing request
	val.insert_string(ID);
	context.set_one_value("ObjectID", val);

	//set Context of Request Object
	//the parameter of add method ("IR*") specifies which values of context
	//will be sent through. 
	//Here we say "sent all attributes starting with "IR"

	request.contexts().add("Object*");
	request.ctx(context);
	//System.out.println("PCS:insertContextInfo appended Context Info.:"+ID);
			  
    }

   public String  extractObjectID(ServerRequest request)
    {
	String ObjectID=null;

	Context context = request.ctx();
	String contextName = context.context_name();
	//System.out.println("ProxyImpl:extractObjectID:Context name :"+contextName);
	org.omg.CORBA.NVList nvl = context.get_values("",0, "*");
	//	org.omg.CORBA.CTX_RESTRICT_SCOPE.value, "IRid"); 

	//System.out.println("ProxyImpl:extractObjectID:Context name:count:"+nvl.count());	
       	for(int k=0;k<nvl.count();k++){
	    org.omg.CORBA.NamedValue nval=null;
	    try{
		nval = nvl.item(k);
	    }catch(org.omg.CORBA.Bounds e){
		System.out.println("ProxyImpl:Got exception in extract Context:extractObjectID:"+e);
	    }
	    String name = nval.name();
	    Any    any  = nval.value();
	    String attval = any.extract_string();
	    //System.out.println("ProxyImpl:extractObjectID:Contex Info:"+k+" name:"+name+
	    //       " value:"+attval);
	    if (name.equals("ObjectID")){
		//System.out.println("ProxyImpl:extractObjectID:Got Object ID :");
		ObjectID = attval;
	    }
	}
	return ObjectID;
	
    }


   public void forwardFireEvent(org.omg.CORBA.ServerRequest request)
  {
        
   
    //receive event from child
    String opname = request.op_name();
    //System.out.println(attr+"BeanContextChild forwards FIREEVENT call:"+opname);
    org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
    org.omg.CORBA.Any _ob_aa0 = orb.create_any();
    _ob_aa0.type(orb.create_interface_tc("IDL:omg.org/CORBA/Object:1.0","Object"));
    _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
    request.params(_ob_list);
    org.omg.CORBA.Object evt = _ob_aa0.extract_Object();

    //receive incoming context
    //We sent always context info of source modules with fire event
    String objectID = extractObjectID(request);
    //Recive Context Info

    //forward event now
    org.omg.CORBA.Request _ob_req = childPeer._request(opname);
    org.omg.CORBA.Any _ob_aa1 = _ob_req.add_in_arg();
     
    //append incoming context Info
    insertContextInfo(_ob_req, objectID);  
    //append context Info

    _ob_aa1.insert_Object(evt);
    _ob_req.invoke();

    java.lang.Exception _ob_ex = _ob_req.env().exception();
    if(_ob_ex != null)
      throw (org.omg.CORBA.SystemException)_ob_ex;

  }

 
  
 }


